"use strict";

var __extends = undefined && undefined.__extends || function () {
    var extendStatics = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function (d, b) {
        d.__proto__ = b;
    } || function (d, b) {
        for (var p in b) {
            if (b.hasOwnProperty(p)) d[p] = b[p];
        }
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() {
            this.constructor = d;
        }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
}();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_redux_1 = require("react-redux");
var createStore_1 = require("../createStore");
var Playground_1 = require("./Playground");
var react_helmet_1 = require("react-helmet");
var store = createStore_1.default();
function getParameterByName(name) {
    var url = window.location.href;
    name = name.replace(/[\[\]]/g, '\\$&');
    var regexa = new RegExp('[?&]' + name + '(=([^&#]*)|&|#|$)');
    var results = regexa.exec(url);
    if (!results || !results[2]) {
        return null;
    }
    return decodeURIComponent(results[2].replace(/\+/g, ' '));
}
var MiddlewareApp = /** @class */function (_super) {
    __extends(MiddlewareApp, _super);
    function MiddlewareApp(props) {
        var _this = _super.call(this, props) || this;
        _this.share = function (session) {
            fetch('https://api.graph.cool/simple/v1/cj81hi46q03c30196uxaswrz2', {
                method: 'post',
                headers: {
                    'Content-Type': 'application/json'
                },
                body: JSON.stringify({
                    query: "\n        mutation ($session: String! $endpoint: String!) {\n          addSession(session: $session endpoint: $endpoint) {\n            id\n          }\n        }\n      ",
                    variables: {
                        session: JSON.stringify(session),
                        endpoint: _this.normalizeEndpoint(_this.state.endpoint)
                    }
                })
            }).then(function (res) {
                return res.json();
            }).then(function (res) {
                var shareUrl = "https://graphqlbin.com/" + res.data.addSession.id;
                // const shareUrl = `${location.origin}/${res.data.addSession.id}`
                _this.setState({ shareUrl: shareUrl });
            });
        };
        _this.handleChangeEndpoint = function (endpoint) {
            _this.setState({ endpoint: endpoint });
        };
        _this.handleChangeSubscriptionsEndpoint = function (subscriptionEndpoint) {
            _this.setState({ subscriptionEndpoint: subscriptionEndpoint });
        };
        var endpoint = props.endpoint || getParameterByName('endpoint') || location.href;
        _this.state = {
            endpoint: endpoint,
            platformToken: localStorage.getItem('platform-token') || undefined,
            subscriptionEndpoint: props.subscriptionEndpoint || getParameterByName('subscriptionEndpoint') || getSubscriptionsUrl(endpoint)
        };
        return _this;
    }
    MiddlewareApp.prototype.componentWillMount = function () {
        var platformToken = getParameterByName('platform-token');
        if (platformToken && platformToken.length > 0) {
            localStorage.setItem('platform-token', platformToken);
            window.location.replace(window.location.origin + window.location.pathname);
        }
    };
    MiddlewareApp.prototype.render = function () {
        return React.createElement(
            "div",
            null,
            React.createElement(
                react_helmet_1.Helmet,
                null,
                React.createElement(
                    "title",
                    null,
                    this.getTitle()
                )
            ),
            React.createElement(
                react_redux_1.Provider,
                { store: store },
                React.createElement(Playground_1.default, { endpoint: this.state.endpoint, subscriptionsEndpoint: this.state.subscriptionEndpoint, share: this.share, shareUrl: this.state.shareUrl, onChangeEndpoint: this.handleChangeEndpoint, onChangeSubscriptionsEndpoint: this.handleChangeSubscriptionsEndpoint, adminAuthToken: this.state.platformToken })
            )
        );
    };
    MiddlewareApp.prototype.normalizeEndpoint = function (endpoint) {
        if (!endpoint.match(/https?:\/\/(.*?)\//)) {
            return location.origin + endpoint;
        } else {
            return endpoint;
        }
    };
    MiddlewareApp.prototype.getTitle = function () {
        if (this.state.platformToken || this.state.endpoint.includes('api.graph.cool')) {
            var projectId = getProjectId(this.state.endpoint);
            var cluster = this.state.endpoint.includes('api.graph.cool') ? 'shared' : 'local';
            return cluster + "/" + projectId + " - Playground";
        }
        return "Playground - " + this.state.endpoint;
    };
    return MiddlewareApp;
}(React.Component);
exports.default = MiddlewareApp;
function getSubscriptionsUrl(endpoint) {
    if (endpoint.includes('graph.cool')) {
        return "wss://subscriptions.graph.cool/v1/" + getProjectId(endpoint);
    }
    if (endpoint.includes('localhost') && endpoint.includes('/simple/')) {
        // it's a graphcool local endpoint
        var host = endpoint.match(/https?:\/\/(.*?)\//);
        return "ws://" + host[1] + "/subscriptions/v1/" + getProjectId(endpoint);
    }
    return endpoint;
}
function getProjectId(endpoint) {
    return endpoint.split('/').slice(-1)[0];
}
//# sourceMappingURL=MiddlewareApp.jsx.map