"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var Icon_1 = require("graphcool-styles/dist/components/Icon/Icon");
var graphcool_styles_1 = require("graphcool-styles");
var Tooltip_1 = require("../Tooltip");
var cn = require("classnames");
var TypeChooser_1 = require("./TypeChooser");
var Button_1 = require("../Button");
var NewPermissionTab = /** @class */ (function (_super) {
    __extends(NewPermissionTab, _super);
    function NewPermissionTab(props) {
        var _this = _super.call(this, props) || this;
        _this.handleModelNameChange = function (e) {
            _this.setState({ modelName: e.target.value });
        };
        _this.handleRelationNameChange = function (e) {
            _this.setState({ relationName: e.target.value });
        };
        _this.newTab = function () {
            _this.toggleTooltip();
            _this.props.onNewPermissionTab({
                relationName: _this.state.modelSelected
                    ? undefined
                    : _this.state.relationName,
                modelName: _this.state.modelSelected ? _this.state.modelName : undefined,
            });
        };
        _this.toggleType = function () {
            _this.setState(function (state) { return ({ modelSelected: !state.modelSelected }); });
        };
        //
        // private handleChangeEndpoint = e => {
        //   if (typeof this.props.onChangeEndpoint === 'function') {
        //     this.props.onChangeEndpoint(e.target.value)
        //   }
        // }
        //
        // private handleChangeSubscriptionsEndpoint = e => {
        //   if (typeof this.props.onChangeSubscriptionsEndpoint === 'function') {
        //     this.props.onChangeSubscriptionsEndpoint(e.target.value)
        //   }
        // }
        _this.toggleTooltip = function () {
            _this.setState(function (state) { return ({ open: !state.open }); });
        };
        _this.state = {
            open: false,
            modelSelected: true,
            modelName: props.serviceInformation.models &&
                props.serviceInformation.models.length > 0
                ? props.serviceInformation.models[0].name
                : '',
            relationName: props.serviceInformation.relations &&
                props.serviceInformation.relations.length > 0
                ? props.serviceInformation.relations[0].name
                : '',
        };
        return _this;
    }
    NewPermissionTab.prototype.render = function () {
        var _a = this.state, open = _a.open, modelSelected = _a.modelSelected, modelName = _a.modelName, relationName = _a.relationName;
        var _b = this.props, theme = _b.theme, serviceInformation = _b.serviceInformation;
        return (<div className="settings">
        <style jsx={true}>{"\n          .settings {\n            @p: .absolute;\n            z-index: 1005;\n            right: 203px;\n            top: 17px;\n          }\n          .tooltip-text {\n            @p: .mr10, .darkBlue50, .fw6, .ttu, .f14;\n            letter-spacing: 0.53px;\n          }\n          .icon {\n            @p: .pointer, .relative;\n          }\n\n          .icon:hover :global(.permission-icon) :global(svg),\n          .icon.open :global(.permission-icon) :global(svg) {\n            fill: $white60;\n          }\n          .icon.light:hover :global(.permission-icon) :global(svg),\n          .icon.light.open :global(.permission-icon) :global(svg) {\n            fill: $darkBlue60;\n          }\n\n          .icon:hover :global(.stroke) :global(svg),\n          .icon.open :global(.stroke) :global(svg) {\n            fill: $white60;\n            stroke: $white60;\n          }\n          .icon.light:hover :global(.stroke) :global(svg),\n          .icon.light.open :global(.stroke) :global(svg) {\n            fill: $darkBlue60;\n            stroke: $darkBlue60;\n          }\n\n          .icon .permission-icon {\n            @p: .relative;\n          }\n          .icon .permission-icon :global(.plus) {\n            @p: .absolute;\n            right: -5px;\n            top: 12px;\n          }\n          .tooltip {\n            @p: .absolute;\n            right: -21px;\n          }\n          .row {\n            @p: .flex, .itemsCenter, .justifyBetween;\n            min-width: 245px;\n          }\n          .row + .row {\n            @p: .mt16;\n          }\n          .button {\n            @p: .br2, .f14, .fw6, .ttu, .darkBlue40;\n            background: #e9eaeb;\n            padding: 5px 9px 6px 9px;\n          }\n          .button:hover {\n            @p: .darkBlue50;\n            background: #dbdcdc;\n          }\n          input {\n            @p: .bgDarkBlue10, .br2, .pv6, .ph10, .fw6, .darkBlue, .f12, .db,\n              .w100;\n          }\n          b {\n            @p: .fw6, .db;\n          }\n          .permission-type {\n            @p: .mb10;\n          }\n          .chooser {\n            @p: .mb25;\n          }\n          .select {\n            @p: .relative, .flexAuto;\n          }\n          .select + .select {\n            @p: .ml16;\n          }\n          select {\n            @p: .relative, .darkBlue80;\n            background: none;\n            padding-right: 30px;\n            background: $darkBlue04;\n            border: none;\n            border-radius: 2px;\n            -webkit-appearance: none;\n            -moz-appearance: none;\n            appearance: none;\n\n            width: 100%;\n            margin: 0;\n            outline: none;\n            padding: .5em .8em .6em .8em;\n\n            /* Prefixed box-sizing rules necessary for older browsers */\n            -webkit-box-sizing: border-box;\n            -moz-box-sizing: border-box;\n            box-sizing: border-box;\n\n            /* Font size must be 16px to prevent iOS page zoom on focus */\n            font-size: 16px;\n          }\n          .arrow {\n            @p: .absolute, .darkBlue80;\n            pointer-events: none;\n            top: 6px;\n            right: 8px;\n          }\n          .selects {\n            @p: .flex;\n          }\n        "}</style>
        <div className={cn('icon', theme, { open: open })}>
          <div className="permission-icon" onClick={this.toggleTooltip}>
            <Icon_1.default src={require('graphcool-styles/icons/fill/permissions.svg')} color={theme === 'light' ? graphcool_styles_1.$v.darkBlue20 : graphcool_styles_1.$v.white20} width={23} height={23}/>
            <Icon_1.default src={require('graphcool-styles/icons/stroke/addFull.svg')} color={theme === 'light' ? 'rgb(179,187,191)' : 'rgb(58,67,74)'} stroke={true} strokeWidth={6} width={12} height={12} className="plus stroke"/>
          </div>
          <div className="tooltip">
            <Tooltip_1.default open={open} onClose={this.toggleTooltip} anchorOrigin={{
            horizontal: 'right',
            vertical: 'bottom',
        }}>
              <div>
                <div className="row chooser">
                  <div>
                    <div className="permission-type">Permission Type</div>
                    <TypeChooser_1.default modelSelected={this.state.modelSelected} onToggle={this.toggleType}/>
                  </div>
                </div>
                {modelSelected
            ? <div className="row">
                      <div className="selects w100">
                        <div className="select">
                          <select value={modelName} onChange={this.handleModelNameChange}>
                            {serviceInformation.models.map(function (model) {
                return <option value={model.name} key={model.id}>
                                {model.name}
                              </option>;
            })}
                          </select>
                          <div className="arrow">▾</div>
                        </div>
                      </div>
                    </div>
            : <div className="row">
                      <div className="select w100">
                        <select value={relationName} onChange={this.handleRelationNameChange} className="w100">
                          {serviceInformation.relations.map(function (relation) {
                return <option value={relation.name} key={relation.name}>
                              {relation.name}
                            </option>;
            })}
                        </select>
                        <div className="arrow">▾</div>
                      </div>
                    </div>}
                <div className="row">
                  <Button_1.Button green={true} onClick={this.newTab}>
                    New Permission Tab
                  </Button_1.Button>
                </div>
              </div>
            </Tooltip_1.default>
          </div>
        </div>
      </div>);
    };
    return NewPermissionTab;
}(React.Component));
exports.default = NewPermissionTab;
//# sourceMappingURL=NewPermissionTab.jsx.map