/// <reference types="react" />
import * as React from 'react';
import { PermissionSession, ServiceInformation, Session } from '../../types';
import { Header } from './HttpHeaders/HttpHeaders';
export interface Props {
    session: Session;
    index: number;
    onRef: (index: number, ref: any) => void;
    isGraphcoolUrl: boolean;
    fetcher: (session: Session, graphQLParams: any) => Promise<any>;
    schemaCache: any;
    isEndpoint: boolean;
    adminAuthToken?: string;
    storage?: any;
    onEditQuery: (sessionId: string, data: any) => void;
    onEditVariables: (sessionId: string, variables: any) => any;
    onEditOperationName: (sessionId: string, name: any) => any;
    onClickCodeGeneration: any;
    onChangeHeaders: (sessionId: string, headers: Header[]) => any;
    autofillMutation?: () => void;
    onChangeViewer: (sessionId: string, data: any) => void;
    headers?: any[];
    disableQueryHeader?: boolean;
    disableResize?: boolean;
    responses?: any;
    useVim: boolean;
    isActive: boolean;
    onboardingStep?: any;
    tether?: any;
    nextStep?: () => void;
    permission?: PermissionSession;
    serviceInformation?: ServiceInformation;
}
export default class GraphQLEditorSession extends React.PureComponent<Props, {}> {
    fetcher: (graphQLParams: any) => Promise<any>;
    render(): JSX.Element;
    private setRef;
    private handleViewerChange;
    private handleOperationNameChange;
    private handleVariableChange;
    private handleQueryChange;
    private handleChangeHeaders;
}
