"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var GraphQLEditor_1 = require("./GraphQLEditor");
var GraphQLEditorSession = /** @class */ (function (_super) {
    __extends(GraphQLEditorSession, _super);
    function GraphQLEditorSession() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.fetcher = function (graphQLParams) {
            return _this.props.fetcher(_this.props.session, graphQLParams);
        };
        _this.setRef = function (ref) {
            _this.props.onRef(_this.props.index, ref);
        };
        _this.handleViewerChange = function (viewer) {
            _this.props.onChangeViewer(_this.props.session.id, viewer);
        };
        _this.handleOperationNameChange = function (name) {
            _this.props.onEditOperationName(_this.props.session.id, name);
        };
        _this.handleVariableChange = function (variables) {
            _this.props.onEditVariables(_this.props.session.id, variables);
        };
        _this.handleQueryChange = function (query) {
            _this.props.onEditQuery(_this.props.session.id, query);
        };
        _this.handleChangeHeaders = function (headers) {
            _this.props.onChangeHeaders(_this.props.session.id, headers);
        };
        return _this;
    }
    GraphQLEditorSession.prototype.render = function () {
        var _a = this.props, session = _a.session, isGraphcoolUrl = _a.isGraphcoolUrl, schemaCache = _a.schemaCache, adminAuthToken = _a.adminAuthToken, isEndpoint = _a.isEndpoint, storage = _a.storage, responses = _a.responses, disableQueryHeader = _a.disableQueryHeader, onboardingStep = _a.onboardingStep, tether = _a.tether, nextStep = _a.nextStep, isActive = _a.isActive, permission = _a.permission, serviceInformation = _a.serviceInformation;
        return (<GraphQLEditor_1.GraphQLEditor isActive={isActive} key={session.id} isGraphcoolUrl={isGraphcoolUrl} schema={schemaCache} fetcher={this.fetcher} showQueryTitle={false} showResponseTitle={false} showViewAs={Boolean(adminAuthToken)} showSelectUser={Boolean(this.props.adminAuthToken)} showEndpoints={!isEndpoint} showDownloadJsonButton={true} showCodeGeneration={true} selectedViewer={session.selectedViewer} storage={storage} query={session.query} variables={session.variables} operationName={session.operationName} headers={session.headers} onClickCodeGeneration={this.props.onClickCodeGeneration} onChangeViewer={this.handleViewerChange} onEditOperationName={this.handleOperationNameChange} onEditVariables={this.handleVariableChange} onEditQuery={this.handleQueryChange} onChangeHeaders={this.handleChangeHeaders} responses={responses} disableQueryHeader={disableQueryHeader} disableResize={true} onboardingStep={onboardingStep} tether={tether} nextStep={nextStep} ref={this.setRef} autofillMutation={this.props.autofillMutation} useVim={this.props.useVim} rerenderQuery={this.props.onboardingStep === 'STEP3_ENTER_MUTATION1_VALUES' ||
            this.props.onboardingStep === 'STEP3_ENTER_MUTATION2_VALUE'} disableAnimation={true} disableAutofocus={!isActive} permission={permission} serviceInformation={serviceInformation}/>);
    };
    return GraphQLEditorSession;
}(React.PureComponent));
exports.default = GraphQLEditorSession;
//# sourceMappingURL=GraphQLEditorSession.jsx.map