"use strict";

var _style = require("styled-jsx/style");

var _style2 = _interopRequireDefault(_style);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var __extends = undefined && undefined.__extends || function () {
    var extendStatics = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function (d, b) {
        d.__proto__ = b;
    } || function (d, b) {
        for (var p in b) {
            if (b.hasOwnProperty(p)) d[p] = b[p];
        }
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() {
            this.constructor = d;
        }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
}();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var graphcool_styles_1 = require("graphcool-styles");
var VariableTag_1 = require("./VariableTag");
var operations = {
    'Current Node': ['read', 'update', 'delete'],
    'Existing Scalar Values': ['read', 'update', 'delete'],
    'Scalar Values': ['update', 'create']
};
var PermissionVariables = /** @class */function (_super) {
    __extends(PermissionVariables, _super);
    function PermissionVariables(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {};
        return _this;
    }
    PermissionVariables.prototype.render = function () {
        var _this = this;
        var variables = this.props.variables;
        return React.createElement(
            "div",
            { className: "permission-variables", "data-jsx": 1625059327
            },
            React.createElement(_style2.default, {
                styleId: 1625059327,
                css: ".permission-variables[data-jsx=\"1625059327\"] {background: #142533;padding: 20px;padding-top: 26px;border-top: 8px solid rgba(23, 42, 58, 1);}.z2,\n.permission-variables[data-jsx=\"1625059327\"] {z-index: 2;}.overflowYScroll,\n.permission-variables[data-jsx=\"1625059327\"] {overflow-y: scroll;}.flexFixed,\n.permission-variables[data-jsx=\"1625059327\"] {-ms-flex: 0 0 auto;flex: 0 0 auto;}.mb6,\n.tag {margin-bottom: 6px;}.mr6,\n.tag {margin-right: 6px;}.pb38,\n.variable-category[data-jsx=\"1625059327\"] {padding-bottom: 38px;}.fw6,\n.variable-title[data-jsx=\"1625059327\"],\nh3[data-jsx=\"1625059327\"],\n.operation[data-jsx=\"1625059327\"] {font-weight: 600;}.f12,\n.variable-title[data-jsx=\"1625059327\"],\n.operation[data-jsx=\"1625059327\"] {font-size: 12px;}.white30,\n.variable-title[data-jsx=\"1625059327\"] {color: hsla(0,0%,100%,.3);}.ttu,\n.variable-title[data-jsx=\"1625059327\"],\nh3[data-jsx=\"1625059327\"] {text-transform: uppercase;}.mb16,\n.variable-title[data-jsx=\"1625059327\"] {margin-bottom: 16px;}.flex,\n.variable-title[data-jsx=\"1625059327\"] {display: -ms-flexbox;display: flex;}.itemsCenter,\n.variable-title[data-jsx=\"1625059327\"] {-webkit-box-align: center;-ms-flex-align: center;-ms-grid-row-align: center;align-items: center;}.white40,\nh3[data-jsx=\"1625059327\"] {color: hsla(0,0%,100%,.4);}.fw6,\n.variable-title[data-jsx=\"1625059327\"],\nh3[data-jsx=\"1625059327\"],\n.operation[data-jsx=\"1625059327\"] {font-weight: 600;}.ttu,\n.variable-title[data-jsx=\"1625059327\"],\nh3[data-jsx=\"1625059327\"] {text-transform: uppercase;}.mt0,\nh3[data-jsx=\"1625059327\"] {margin-top: 0;}.mb25,\nh3[data-jsx=\"1625059327\"] {margin-bottom: 25px;}.white80,\n.operation[data-jsx=\"1625059327\"] {color: hsla(0,0%,100%,.8);}.fw6,\n.variable-title[data-jsx=\"1625059327\"],\nh3[data-jsx=\"1625059327\"],\n.operation[data-jsx=\"1625059327\"] {font-weight: 600;}.f12,\n.variable-title[data-jsx=\"1625059327\"],\n.operation[data-jsx=\"1625059327\"] {font-size: 12px;}.ml6,\n.operation[data-jsx=\"1625059327\"] + .operation[data-jsx=\"1625059327\"] {margin-left: 6px;}"
            }),
            React.createElement(
                "h3",
                {
                    "data-jsx": 1625059327
                },
                "Permission Variables"
            ),
            this.sortVariables(Object.keys(variables)).map(function (group) {
                return React.createElement(
                    "div",
                    { className: "variable-category", key: group, "data-jsx": 1625059327
                    },
                    React.createElement(
                        "div",
                        { className: "variable-title", "data-jsx": 1625059327
                        },
                        React.createElement(
                            "span",
                            {
                                "data-jsx": 1625059327
                            },
                            group,
                            operations[group] && [' ( ', operations[group].map(function (operation, index) {
                                return React.createElement(
                                    "span",
                                    { className: "operation", "data-jsx": 1625059327
                                    },
                                    operation,
                                    index < operations[group].length - 1 ? ',' : ''
                                );
                            }), ' )']
                        ),
                        group === 'Authenticated User' && React.createElement(graphcool_styles_1.Icon, { src: require('graphcool-styles/icons/stroke/lock.svg'), color: graphcool_styles_1.$v.white40, stroke: true, strokeWidth: 2.5, height: 18, width: 18, className: "ml10" })
                    ),
                    variables[group].map(function (variable) {
                        return React.createElement(VariableTag_1.default, { key: variable.name, active: _this.props.selectedVariableNames.includes(variable.name), className: "tag", variable: variable });
                    })
                );
            })
        );
    };
    //
    // private toggleVariableSelection = variable => () => {
    //   this.props.onToggleVariableSelection(variable)
    // }
    PermissionVariables.prototype.sortVariables = function (categories) {
        var cats = categories.slice();
        return cats.sort(function (a, b) {
            if (a === 'Authenticated User') {
                return -1;
            }
            if (b === 'Authenticated User') {
                return 1;
            }
            return a < b ? -1 : 1;
        });
    };
    return PermissionVariables;
}(React.Component);
exports.default = PermissionVariables;
//# sourceMappingURL=PermissionVariables.jsx.map