"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var graphcool_styles_1 = require("graphcool-styles");
var VariableTag_1 = require("./VariableTag");
var operations = {
    'Current Node': ['read', 'update', 'delete'],
    'Existing Scalar Values': ['read', 'update', 'delete'],
    'Scalar Values': ['update', 'create'],
};
var PermissionVariables = /** @class */ (function (_super) {
    __extends(PermissionVariables, _super);
    function PermissionVariables(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {};
        return _this;
    }
    PermissionVariables.prototype.render = function () {
        var _this = this;
        var variables = this.props.variables;
        return (<div className="permission-variables">
        <style jsx={true}>{"\n          .permission-variables {\n            @p: .z2, .overflowYScroll, .flexFixed;\n            background: #142533;\n            padding: 20px;\n            padding-top: 26px;\n            :global(.tag) {\n              @p: .mb6, .mr6;\n            }\n            border-top: 8px solid rgba(23, 42, 58, 1);\n          }\n          .variable-category {\n            @p: .pb38;\n          }\n          .variable-title {\n            @p: .fw6, .f12, .white30, .ttu, .mb16, .flex, .itemsCenter;\n          }\n          h3 {\n            @p: .white40, .fw6, .ttu, .mt0, .mb25;\n          }\n          .operation {\n            @p: .white80, .fw6, .f12;\n          }\n          .operation + .operation {\n            @p: .ml6;\n          }\n        "}</style>
        <h3>Permission Variables</h3>
        {this.sortVariables(Object.keys(variables)).map(function (group) {
            return <div className="variable-category" key={group}>
            <div className="variable-title">
              <span>
                {group}
                {operations[group] && [
                ' ( ',
                operations[group].map(function (operation, index) {
                    return <span className="operation">
                      {operation}
                      {index < operations[group].length - 1 ? ',' : ''}
                    </span>;
                }),
                ' )',
            ]}
              </span>
              {group === 'Authenticated User' &&
                <graphcool_styles_1.Icon src={require('graphcool-styles/icons/stroke/lock.svg')} color={graphcool_styles_1.$v.white40} stroke={true} strokeWidth={2.5} height={18} width={18} className="ml10"/>}
            </div>
            {variables[group].map(function (variable) {
                return <VariableTag_1.default key={variable.name} active={_this.props.selectedVariableNames.includes(variable.name)} className="tag" variable={variable}/>;
            })}
          </div>;
        })}
      </div>);
    };
    //
    // private toggleVariableSelection = variable => () => {
    //   this.props.onToggleVariableSelection(variable)
    // }
    PermissionVariables.prototype.sortVariables = function (categories) {
        var cats = categories.slice();
        return cats.sort(function (a, b) {
            if (a === 'Authenticated User') {
                return -1;
            }
            if (b === 'Authenticated User') {
                return 1;
            }
            return a < b ? -1 : 1;
        });
    };
    return PermissionVariables;
}(React.Component));
exports.default = PermissionVariables;
//# sourceMappingURL=PermissionVariables.jsx.map