"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var ViewerChooser_1 = require("./ResultHeader/ViewerChooser");
var cx = require("classnames");
var ResultHeader = function (_a) {
    var selectedViewer = _a.selectedViewer, onChangeViewer = _a.onChangeViewer, showViewAs = _a.showViewAs, showResponseTitle = _a.showResponseTitle, showSelectUser = _a.showSelectUser;
    return <div className={cx('result-header subscription')}>
    <style jsx={true}>{"\n      .result-header {\n        @inherit: .bgDarkBlue,\n          .flex,\n          .justifyBetween,\n          .itemsCenter,\n          .relative,\n          .mr25,\n          .pl16;\n        padding-top: 13px;\n        margin-left: 38px;\n        height: 75px;\n        &.subscription {\n          &:after {\n            content: \"\";\n            position: absolute;\n            bottom: -25px;\n            left: 0;\n            right: 0;\n            height: 25px;\n            background: linear-gradient(\n              to bottom,\n              rgba(23, 42, 58, 1) 0%,\n              rgba(23, 42, 58, 0) 100%\n            );\n            z-index: 4;\n          }\n        }\n      }\n      .inner {\n        @inherit: .absolute;\n      }\n    "}</style>
    <div className="inner">
      <div>
        {showResponseTitle && <div className="editor-title">Response</div>}
      </div>
      {showViewAs &&
        selectedViewer &&
        onChangeViewer &&
        <ViewerChooser_1.default showSelectUser={showSelectUser} selectedViewer={selectedViewer} onChangeViewer={onChangeViewer}/>}
    </div>
  </div>;
};
exports.default = ResultHeader;
//# sourceMappingURL=ResultHeader.jsx.map