"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var cx = require("classnames");
var graphcool_styles_1 = require("graphcool-styles");
var ViewAs = /** @class */ (function (_super) {
    __extends(ViewAs, _super);
    function ViewAs() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.handleChangeAdminViewer = function () {
            _this.props.onChangeViewer('ADMIN');
        };
        _this.handleChangeEveryoneViewer = function () {
            _this.props.onChangeViewer('EVERYONE');
        };
        _this.handleChangeUserViewer = function () {
            _this.props.onChangeViewer('USER');
        };
        return _this;
    }
    ViewAs.prototype.render = function () {
        var _a = this.props, selectedViewer = _a.selectedViewer, showSelectUser = _a.showSelectUser;
        return (<div className="root">
        <style jsx={true}>{"\n          .root {\n            @p: .fw6, .flex, .itemsCenter;\n            color: rgba(255, 255, 255, .25);\n          }\n\n          .chooser {\n            @p: .ml16, .flex, .itemsCenter;\n          }\n\n          .viewer {\n            @p: .br2, .relative, .pointer, .ttu, .flex, .itemsCenter;\n            padding: 5px 13px 6px 13px;\n            margin: 0 -2px;\n            background-color: #08131b;\n            &.active {\n              @p: .bgLightGray, .darkerBlue;\n              padding: 7px 9px 8px 9px;\n              z-index: 2;\n            }\n          }\n\n          .viewer-text {\n            @p: .ml6, .nowrap;\n          }\n        "}</style>

        <div className="nowrap">View As</div>
        <div className="chooser">
          <div className={cx('viewer', {
            active: selectedViewer === 'ADMIN',
        })} onClick={this.handleChangeAdminViewer}>
            Admin
          </div>
          <div className={cx('viewer', {
            active: selectedViewer === 'EVERYONE',
        })} onClick={this.handleChangeEveryoneViewer}>
            <graphcool_styles_1.Icon src={require('graphcool-styles/icons/fill/world.svg')} color={selectedViewer === 'EVERYONE' ? graphcool_styles_1.$v.darkerBlue : graphcool_styles_1.$v.white30} width={14} height={14}/>
            <div className="viewer-text">Everyone</div>
          </div>
          {showSelectUser &&
            <div className={cx('viewer', {
                active: selectedViewer === 'USER',
            })} onClick={this.handleChangeUserViewer}>
              <graphcool_styles_1.Icon src={require('graphcool-styles/icons/fill/user.svg')} color={selectedViewer === 'USER' ? graphcool_styles_1.$v.darkerBlue : graphcool_styles_1.$v.white30} width={14} height={14}/>
              <div className="viewer-text">Select User</div>
            </div>}
        </div>
      </div>);
    };
    return ViewAs;
}(React.Component));
exports.default = ViewAs;
//# sourceMappingURL=ViewerChooser.jsx.map