"use strict";

var _style = require("styled-jsx/style");

var _style2 = _interopRequireDefault(_style);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var cx = require("classnames");
var graphcool_styles_1 = require("graphcool-styles");
var withTheme_1 = require("../Theme/withTheme");
var Tab_1 = require("./Tab");
exports.TabBar = withTheme_1.default(function (_a) {
  var sessions = _a.sessions,
      selectedSessionIndex = _a.selectedSessionIndex,
      onNewSession = _a.onNewSession,
      onSelectSession = _a.onSelectSession,
      onOpenHistory = _a.onOpenHistory,
      onCloseSession = _a.onCloseSession,
      onboardingStep = _a.onboardingStep,
      tether = _a.tether,
      theme = _a.theme,
      isApp = _a.isApp,
      nextStep = _a.nextStep;
  var Tether = tether;
  return React.createElement(
    "div",
    { className: cx('tabbar', theme), "data-jsx": 1735174096
    },
    React.createElement(_style2.default, {
      styleId: 1735174096,
      css: ".tab[data-jsx=\"1735174096\"] {height: 43px;padding: 10px;padding-top: 9px}.light[data-jsx=\"1735174096\"] .tab[data-jsx=\"1735174096\"] {background-color: #e7eaec}.light[data-jsx=\"1735174096\"] .tab[data-jsx=\"1735174096\"].active[data-jsx=\"1735174096\"] {background-color: #eeeff0}.tabbar[data-jsx=\"1735174096\"] {height: 57px;background-color: rgba(9, 20, 28, 1);-webkit-app-region: drag;path[data-jsx=\"1735174096\"] {stroke: white;}}.tabbar.light[data-jsx=\"1735174096\"] {background-color: #dbdee0;}.tabs[data-jsx=\"1735174096\"] {margin-right: 240px;}.tabs.isApp[data-jsx=\"1735174096\"] {padding-left: 52px;}.red-dot[data-jsx=\"1735174096\"] {width: 7px;height: 7px;}.query-type[data-jsx=\"1735174096\"] {height: 21px;width: 21px;margin-right: 2px;}.close[data-jsx=\"1735174096\"] {top: 1px}.plus[data-jsx=\"1735174096\"] {width: 43px;}.history[data-jsx=\"1735174096\"] {top: 15px;right: 56px;}.change-theme[data-jsx=\"1735174096\"] {top: 200px;right: 200px;}.border-bottom[data-jsx=\"1735174096\"] {height: 8px;background-color: #eeeff0;width: 100%;}.light.tab[data-jsx=\"1735174096\"]:hover {background-color: #eeeff0;}.history[data-jsx=\"1735174096\"]:hover .icon svg,.history.open[data-jsx=\"1735174096\"] .icon svg {stroke: rgba(255, 255, 255, .6);}.history.light[data-jsx=\"1735174096\"]:hover .icon svg,.history.light.open[data-jsx=\"1735174096\"] .icon svg {stroke: rgba(23, 42, 58, .6);}.flex,\n.tab[data-jsx=\"1735174096\"],\n.tabs[data-jsx=\"1735174096\"],\n.icons[data-jsx=\"1735174096\"],\n.query-type[data-jsx=\"1735174096\"],\n.plus[data-jsx=\"1735174096\"] {display: -ms-flexbox;display: flex}.itemsCenter,\n.tab[data-jsx=\"1735174096\"],\n.tabs[data-jsx=\"1735174096\"],\n.icons[data-jsx=\"1735174096\"],\n.query-type[data-jsx=\"1735174096\"],\n.plus[data-jsx=\"1735174096\"] {-webkit-box-align: center;-ms-flex-align: center;-ms-grid-row-align: center;align-items: center}.bgDarkerBlue,\n.tab[data-jsx=\"1735174096\"] {background-color: #0f202e}.br2,\n.tab[data-jsx=\"1735174096\"],\n.query-type[data-jsx=\"1735174096\"] {border-radius: 2px}.brTop,\n.tab[data-jsx=\"1735174096\"] {border-bottom-right-radius: 0}.brRight,\n.brTop,\n.tab[data-jsx=\"1735174096\"] {border-bottom-left-radius: 0}.ml10,\n.tab[data-jsx=\"1735174096\"],\n.close[data-jsx=\"1735174096\"] {margin-left: 10px}.bbox,\n.tab[data-jsx=\"1735174096\"] {box-sizing: border-box}.pointer:hover,\n.tab[data-jsx=\"1735174096\"]:hover,\n.history[data-jsx=\"1735174096\"]:hover,\n.change-theme[data-jsx=\"1735174096\"]:hover {cursor: pointer}.bgDarkBlue,\n.tab[data-jsx=\"1735174096\"].active[data-jsx=\"1735174096\"],\n.tab[data-jsx=\"1735174096\"]:hover {background-color: #172a3a}.white,\n.tabbar[data-jsx=\"1735174096\"],\n.light[data-jsx=\"1735174096\"] .query-type[data-jsx=\"1735174096\"] {color: #fff}.z4,\n.tabbar[data-jsx=\"1735174096\"] {z-index: 4}.darkBlue50,\n.tabbar.light[data-jsx=\"1735174096\"] {color: rgba(23,42,58,.5)}.mt16,\n.tabs[data-jsx=\"1735174096\"] {margin-top: 16px}.ml16,\n.tabs[data-jsx=\"1735174096\"] {margin-left: 16px}.flex,\n.tab[data-jsx=\"1735174096\"],\n.tabs[data-jsx=\"1735174096\"],\n.icons[data-jsx=\"1735174096\"],\n.query-type[data-jsx=\"1735174096\"],\n.plus[data-jsx=\"1735174096\"] {display: -ms-flexbox;display: flex}.itemsCenter,\n.tab[data-jsx=\"1735174096\"],\n.tabs[data-jsx=\"1735174096\"],\n.icons[data-jsx=\"1735174096\"],\n.query-type[data-jsx=\"1735174096\"],\n.plus[data-jsx=\"1735174096\"] {-webkit-box-align: center;-ms-flex-align: center;-ms-grid-row-align: center;align-items: center}.z0,\n.tabs[data-jsx=\"1735174096\"] {z-index: 0}.overflowAuto,\n.tabs[data-jsx=\"1735174096\"] {overflow: auto}.flex,\n.tab[data-jsx=\"1735174096\"],\n.tabs[data-jsx=\"1735174096\"],\n.icons[data-jsx=\"1735174096\"],\n.query-type[data-jsx=\"1735174096\"],\n.plus[data-jsx=\"1735174096\"] {display: -ms-flexbox;display: flex}.itemsCenter,\n.tab[data-jsx=\"1735174096\"],\n.tabs[data-jsx=\"1735174096\"],\n.icons[data-jsx=\"1735174096\"],\n.query-type[data-jsx=\"1735174096\"],\n.plus[data-jsx=\"1735174096\"] {-webkit-box-align: center;-ms-flex-align: center;-ms-grid-row-align: center;align-items: center}.o50,\n.icons[data-jsx=\"1735174096\"],\n.operation-name[data-jsx=\"1735174096\"],\n.close[data-jsx=\"1735174096\"] {opacity: .5}.o100,\n.icons[data-jsx=\"1735174096\"].active[data-jsx=\"1735174096\"],\n.operation-name[data-jsx=\"1735174096\"].active[data-jsx=\"1735174096\"],\n.close[data-jsx=\"1735174096\"].active[data-jsx=\"1735174096\"] {opacity: 1}.br100,\n.red-dot[data-jsx=\"1735174096\"] {border-radius: 100%}.bgrRed,\n.red-dot[data-jsx=\"1735174096\"] {background-color: #f25c54}.mr10,\n.red-dot[data-jsx=\"1735174096\"],\n.viewer[data-jsx=\"1735174096\"] {margin-right: 10px}.br2,\n.tab[data-jsx=\"1735174096\"],\n.query-type[data-jsx=\"1735174096\"] {border-radius: 2px}.flex,\n.tab[data-jsx=\"1735174096\"],\n.tabs[data-jsx=\"1735174096\"],\n.icons[data-jsx=\"1735174096\"],\n.query-type[data-jsx=\"1735174096\"],\n.plus[data-jsx=\"1735174096\"] {display: -ms-flexbox;display: flex}.itemsCenter,\n.tab[data-jsx=\"1735174096\"],\n.tabs[data-jsx=\"1735174096\"],\n.icons[data-jsx=\"1735174096\"],\n.query-type[data-jsx=\"1735174096\"],\n.plus[data-jsx=\"1735174096\"] {-webkit-box-align: center;-ms-flex-align: center;-ms-grid-row-align: center;align-items: center}.justifyCenter,\n.query-type[data-jsx=\"1735174096\"],\n.plus[data-jsx=\"1735174096\"] {-ms-flex-pack: center;justify-content: center}.mr4,\n.query-type[data-jsx=\"1735174096\"] {margin-right: 4px}.fw7,\n.query-type[data-jsx=\"1735174096\"] {font-weight: 700}.f12,\n.query-type[data-jsx=\"1735174096\"] {font-size: 12px}.white,\n.tabbar[data-jsx=\"1735174096\"],\n.light[data-jsx=\"1735174096\"] .query-type[data-jsx=\"1735174096\"] {color: #fff}.bgPurple,\n.subscription[data-jsx=\"1735174096\"] {background-color: #a4036f}.bgBlue,\n.query[data-jsx=\"1735174096\"] {background-color: #2a7ed2}.bgLightOrange,\n.mutation[data-jsx=\"1735174096\"] {background-color: #f18f01}.mr10,\n.red-dot[data-jsx=\"1735174096\"],\n.viewer[data-jsx=\"1735174096\"] {margin-right: 10px}.o50,\n.icons[data-jsx=\"1735174096\"],\n.operation-name[data-jsx=\"1735174096\"],\n.close[data-jsx=\"1735174096\"] {opacity: .5}.o100,\n.icons[data-jsx=\"1735174096\"].active[data-jsx=\"1735174096\"],\n.operation-name[data-jsx=\"1735174096\"].active[data-jsx=\"1735174096\"],\n.close[data-jsx=\"1735174096\"].active[data-jsx=\"1735174096\"] {opacity: 1}.ml10,\n.tab[data-jsx=\"1735174096\"],\n.close[data-jsx=\"1735174096\"] {margin-left: 10px}.o50,\n.icons[data-jsx=\"1735174096\"],\n.operation-name[data-jsx=\"1735174096\"],\n.close[data-jsx=\"1735174096\"] {opacity: .5}.relative,\n.close[data-jsx=\"1735174096\"] {position: relative}.o100,\n.icons[data-jsx=\"1735174096\"].active[data-jsx=\"1735174096\"],\n.operation-name[data-jsx=\"1735174096\"].active[data-jsx=\"1735174096\"],\n.close[data-jsx=\"1735174096\"].active[data-jsx=\"1735174096\"] {opacity: 1}.flex,\n.tab[data-jsx=\"1735174096\"],\n.tabs[data-jsx=\"1735174096\"],\n.icons[data-jsx=\"1735174096\"],\n.query-type[data-jsx=\"1735174096\"],\n.plus[data-jsx=\"1735174096\"] {display: -ms-flexbox;display: flex}.justifyCenter,\n.query-type[data-jsx=\"1735174096\"],\n.plus[data-jsx=\"1735174096\"] {-ms-flex-pack: center;justify-content: center}.itemsCenter,\n.tab[data-jsx=\"1735174096\"],\n.tabs[data-jsx=\"1735174096\"],\n.icons[data-jsx=\"1735174096\"],\n.query-type[data-jsx=\"1735174096\"],\n.plus[data-jsx=\"1735174096\"] {-webkit-box-align: center;-ms-flex-align: center;-ms-grid-row-align: center;align-items: center}.pointer:hover,\n.tab[data-jsx=\"1735174096\"]:hover,\n.history[data-jsx=\"1735174096\"]:hover,\n.change-theme[data-jsx=\"1735174096\"]:hover {cursor: pointer}.absolute,\n.history[data-jsx=\"1735174096\"],\n.change-theme[data-jsx=\"1735174096\"] {position: absolute}.absolute,\n.history[data-jsx=\"1735174096\"],\n.change-theme[data-jsx=\"1735174096\"] {position: absolute}.pointer:hover,\n.tab[data-jsx=\"1735174096\"]:hover,\n.history[data-jsx=\"1735174096\"]:hover,\n.change-theme[data-jsx=\"1735174096\"]:hover {cursor: pointer}.bgDarkBlue,\n.tab[data-jsx=\"1735174096\"].active[data-jsx=\"1735174096\"],\n.tab[data-jsx=\"1735174096\"]:hover {background-color: #172a3a}"
    }),
    React.createElement(
      "div",
      { className: cx('tabs', { isApp: isApp }), "data-jsx": 1735174096
      },
      sessions.map(function (session, index) {
        return React.createElement(Tab_1.default, { key: session.id, session: session, index: index, onSelectSession: onSelectSession, selectedSessionIndex: selectedSessionIndex, onCloseSession: onCloseSession, tether: tether, theme: theme, onboardingStep: onboardingStep });
      }),
      tether && onboardingStep === 'STEP3_CREATE_MUTATION_TAB' ? React.createElement(
        Tether,
        { offsetY: -7, steps: [{
            step: 'STEP3_CREATE_MUTATION_TAB',
            title: 'Apparently, there is no data yet',
            description: 'Click here to create new data'
          }] },
        React.createElement(
          "div",
          { className: "tab plus", onClick: onNewSession, "data-jsx": 1735174096
          },
          React.createElement(graphcool_styles_1.Icon, { src: require('graphcool-styles/icons/stroke/add.svg'), color: theme === 'dark' ? graphcool_styles_1.$v.white20 : graphcool_styles_1.$v.darkBlue20, width: 34, height: 34, stroke: true, strokeWidth: 4 })
        )
      ) : React.createElement(
        "div",
        { className: "tab plus", onClick: onNewSession, "data-jsx": 1735174096
        },
        React.createElement(graphcool_styles_1.Icon, { src: require('graphcool-styles/icons/stroke/add.svg'), color: theme === 'dark' ? graphcool_styles_1.$v.white20 : graphcool_styles_1.$v.darkBlue20, width: 34, height: 34, stroke: true, strokeWidth: 4 })
      ),
      React.createElement(
        "div",
        { className: cx('history', theme), "data-jsx": 1735174096
        },
        React.createElement(graphcool_styles_1.Icon, { className: "icon", src: require('graphcool-styles/icons/stroke/history.svg'), stroke: true, strokeWidth: 4, width: 27, height: 27, color: theme === 'dark' ? graphcool_styles_1.$v.white20 : graphcool_styles_1.$v.gray20, onClick: onOpenHistory })
      )
    ),
    theme === 'light' && React.createElement("div", { className: "border-bottom", "data-jsx": 1735174096
    })
  );
});
//# sourceMappingURL=TabBar.jsx.map