"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var Icon_1 = require("graphcool-styles/dist/components/Icon/Icon");
var graphcool_styles_1 = require("graphcool-styles");
var ToggleButton_1 = require("./ToggleButton");
var Tooltip_1 = require("./Tooltip");
var cn = require("classnames");
var Settings = /** @class */ (function (_super) {
    __extends(Settings, _super);
    function Settings(props) {
        var _this = _super.call(this, props) || this;
        _this.handleChangeEndpoint = function (e) {
            if (typeof _this.props.onChangeEndpoint === 'function') {
                _this.props.onChangeEndpoint(e.target.value);
            }
        };
        _this.handleChangeSubscriptionsEndpoint = function (e) {
            if (typeof _this.props.onChangeSubscriptionsEndpoint === 'function') {
                _this.props.onChangeSubscriptionsEndpoint(e.target.value);
            }
        };
        _this.toggleTooltip = function () {
            _this.setState(function (state) { return ({ open: !state.open }); });
        };
        _this.state = {
            open: false,
            endpointUrl: props.endpoint,
        };
        return _this;
    }
    Settings.prototype.render = function () {
        var open = this.state.open;
        var _a = this.props, theme = _a.theme, onToggleReload = _a.onToggleReload, autoReload = _a.autoReload, onReload = _a.onReload, useVim = _a.useVim, onToggleUseVim = _a.onToggleUseVim;
        return (<div className="settings">
        <style jsx={true}>{"\n          .settings {\n            @p: .absolute;\n            z-index: 1005;\n            right: 20px;\n            top: 17px;\n          }\n          .tooltip-text {\n            @p: .mr10, .darkBlue50, .fw6, .ttu, .f14;\n            letter-spacing: 0.53px;\n          }\n          .icon {\n            @p: .pointer, .relative;\n          }\n          .icon:hover :global(.settings-icon) :global(svg),\n          .icon.open :global(.settings-icon) :global(svg) {\n            fill: $white60;\n          }\n          .icon.light:hover :global(.settings-icon) :global(svg),\n          .icon.light.open :global(.settings-icon) :global(svg) {\n            fill: $darkBlue60;\n          }\n          .tooltip {\n            @p: .absolute;\n            right: -21px;\n          }\n          .row {\n            @p: .flex, .itemsCenter, .justifyBetween;\n            min-width: 245px;\n          }\n          .row + .row {\n            @p: .mt16;\n          }\n          .button {\n            @p: .br2, .f14, .fw6, .ttu, .darkBlue40;\n            background: #e9eaeb;\n            padding: 5px 9px 6px 9px;\n          }\n          .button:hover {\n            @p: .darkBlue50;\n            background: #dbdcdc;\n          }\n          input {\n            @p: .bgDarkBlue10, .br2, .pv6, .ph10, .fw6, .darkBlue, .f12, .db,\n              .w100;\n          }\n          .inner-row {\n            @p: .w100;\n            padding-right: 20px;\n          }\n        "}</style>
        <div className={cn('icon', theme, { open: open })}>
          <Icon_1.default src={require('graphcool-styles/icons/fill/settings.svg')} color={theme === 'light' ? graphcool_styles_1.$v.darkBlue20 : graphcool_styles_1.$v.white20} width={23} height={23} onClick={this.toggleTooltip} className={'settings-icon'}/>
          <div className="tooltip">
            <Tooltip_1.default open={open} onClose={this.toggleTooltip} anchorOrigin={{
            horizontal: 'right',
            vertical: 'bottom',
        }}>
              <div>
                <div className="row">
                  <span className="tooltip-text" onClick={this.props.onToggleTheme}>
                    LIGHT MODE{' '}
                  </span>
                  <ToggleButton_1.default checked={theme === 'light'} onChange={this.props.onToggleTheme}/>
                </div>
                <div className="row">
                  <span className="tooltip-text" onClick={onToggleUseVim}>
                    VIM MODE{' '}
                  </span>
                  <ToggleButton_1.default checked={useVim} onChange={onToggleUseVim}/>
                </div>
                <div className="row">
                  <span className="tooltip-text" onClick={onToggleReload}>
                    AUTO-RELOAD SCHEMA{' '}
                  </span>
                  <ToggleButton_1.default checked={autoReload} onChange={onToggleReload}/>
                </div>
                <div className="row">
                  <div className="button" onClick={onReload}>
                    Reload Schema
                  </div>
                </div>
                <div className="row">
                  <div className="inner-row">
                    <div>Endpoint</div>
                    <input value={this.props.endpoint} placeholder="Enter an endpoint..." onChange={this.handleChangeEndpoint}/>
                  </div>
                </div>
                <div className="row">
                  <div className="inner-row">
                    <div>Subscriptions Endpoint</div>
                    <input value={this.props.subscriptionsEndpoint} placeholder="Enter a subscriptions endpoint..." onChange={this.handleChangeSubscriptionsEndpoint}/>
                  </div>
                </div>
              </div>
            </Tooltip_1.default>
          </div>
        </div>
      </div>);
    };
    return Settings;
}(React.Component));
exports.default = Settings;
//# sourceMappingURL=Settings.jsx.map