"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var Icon_1 = require("graphcool-styles/dist/components/Icon/Icon");
var graphcool_styles_1 = require("graphcool-styles");
var ToggleButton_1 = require("./ToggleButton");
var Tooltip_1 = require("./Tooltip");
var cn = require("classnames");
var Button_1 = require("./Button");
var Copy_1 = require("./Copy");
var Share = /** @class */ (function (_super) {
    __extends(Share, _super);
    function Share(props) {
        var _this = _super.call(this, props) || this;
        _this.toggleTooltip = function () {
            _this.setState(function (state) { return ({ open: !state.open }); });
        };
        _this.state = {
            open: false,
        };
        return _this;
    }
    Share.prototype.render = function () {
        var open = this.state.open;
        var _a = this.props, allTabs = _a.allTabs, httpHeaders = _a.httpHeaders, history = _a.history, onToggleAllTabs = _a.onToggleAllTabs, onToggleHistory = _a.onToggleHistory, onToggleHttpHeaders = _a.onToggleHttpHeaders, theme = _a.theme, shareUrl = _a.shareUrl, onShare = _a.onShare, reshare = _a.reshare;
        return (<div className="settings">
        <style jsx={true}>{"\n          .settings {\n            @p: .absolute;\n            z-index: 1005;\n            right: 96px;\n            top: 13px;\n          }\n          .tooltip-text {\n            @p: .mr10, .darkBlue50, .fw6, .ttu, .f14;\n            letter-spacing: 0.53px;\n          }\n          .icon {\n            @p: .pointer, .relative;\n          }\n          .tooltip {\n            @p: .absolute;\n            right: -21px;\n          }\n          .row {\n            @p: .flex, .itemsCenter, .justifyBetween, .relative;\n            min-width: 245px;\n          }\n          .copy {\n            @p: .absolute, .right0;\n          }\n          .row + .row {\n            @p: .mt16;\n          }\n          .button {\n            @p: .ba, .br2, .f14, .fw6, .ttu, .bWhite20, .flex, .itemsCenter,\n              .white40;\n            padding: 5px 9px 6px 9px;\n          }\n          .button:hover,\n          .button.open {\n            @p: .bWhite70, .white80;\n          }\n          .button span {\n            @p: .ml10;\n          }\n          .button.light {\n            @p: .bDarkBlue10, .darkBlue40;\n          }\n          .button.light:hover,\n          .button.light.open {\n            @p: .bDarkBlue70, .darkBlue80;\n          }\n          .button.light:hover :global(svg),\n          .button.light.open :global(svg) {\n            stroke: $darkBlue80;\n          }\n          .button:hover :global(svg),\n          .button.open :global(svg) {\n            stroke: $white80;\n          }\n          input {\n            @p: .bgDarkBlue10, .br2, .pv6, .ph10, .fw6, .darkBlue, .f12, .db,\n              .w100;\n          }\n          .copy:hover :global(svg) {\n            fill: $darkBlue60;\n          }\n        "}</style>
        <div className="icon">
          <div className={cn('button', this.props.theme, { open: open })} onClick={this.toggleTooltip}>
            <Icon_1.default src={require('../assets/icons/share.svg')} color={theme === 'light' ? graphcool_styles_1.$v.darkBlue40 : graphcool_styles_1.$v.white40} stroke={true} width={13} height={13}/>
            <span>Share</span>
          </div>
          <div className="tooltip">
            <Tooltip_1.default open={open} onClose={this.toggleTooltip} anchorOrigin={{
            horizontal: 'right',
            vertical: 'bottom',
        }}>
              <div>
                <div className="row">
                  <span className="tooltip-text" onClick={onToggleAllTabs}>
                    Share all tabs{' '}
                  </span>
                  <ToggleButton_1.default checked={allTabs} onChange={onToggleAllTabs}/>
                </div>
                <div className="row">
                  <span className="tooltip-text" onClick={onToggleHttpHeaders}>
                    HTTP headers{' '}
                  </span>
                  <ToggleButton_1.default checked={httpHeaders} onChange={onToggleHttpHeaders}/>
                </div>
                <div className="row">
                  <span className="tooltip-text" onClick={onToggleHistory}>
                    History{' '}
                  </span>
                  <ToggleButton_1.default checked={history} onChange={onToggleHistory}/>
                </div>
                {shareUrl &&
            <div className="row">
                    <input value={shareUrl} disabled={true}/>
                    <div className="copy">
                      <Copy_1.default text={shareUrl}>
                        <Icon_1.default src={require('graphcool-styles/icons/fill/copy.svg')} color={graphcool_styles_1.$v.darkBlue30} width={25} height={25}/>
                      </Copy_1.default>
                    </div>
                  </div>}
                <div className="row">
                  <div />
                  <Button_1.Button hideArrow={true} onClick={onShare}>
                    {reshare && shareUrl ? 'Reshare' : 'Share'}
                  </Button_1.Button>
                </div>
              </div>
            </Tooltip_1.default>
          </div>
        </div>
      </div>);
    };
    return Share;
}(React.Component));
exports.default = Share;
//# sourceMappingURL=Share.jsx.map