"use strict";

var _style = require("styled-jsx/style");

var _style2 = _interopRequireDefault(_style);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var __extends = undefined && undefined.__extends || function () {
    var extendStatics = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function (d, b) {
        d.__proto__ = b;
    } || function (d, b) {
        for (var p in b) {
            if (b.hasOwnProperty(p)) d[p] = b[p];
        }
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() {
            this.constructor = d;
        }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
}();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var ReactDOM = require("react-dom");
var cx = require("classnames");
var Tooltip = /** @class */function (_super) {
    __extends(Tooltip, _super);
    function Tooltip() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.handleClickOutside = function (event) {
            if (!_this.props.open) {
                return;
            }
            var domNode = ReactDOM.findDOMNode(_this);
            if ((!domNode || !domNode.contains(event.target)) && typeof _this.props.onClose !== 'undefined') {
                event.stopPropagation();
                _this.props.onClose(event);
            }
        };
        return _this;
    }
    Tooltip.prototype.componentDidMount = function () {
        document.addEventListener('click', this.handleClickOutside.bind(this), true);
    };
    Tooltip.prototype.componentWillUnmount = function () {
        document.removeEventListener('click', this.handleClickOutside.bind(this), true);
    };
    Tooltip.prototype.render = function () {
        var _a = this.props,
            open = _a.open,
            children = _a.children,
            onClick = _a.onClick;
        var anchorOrigin = this.props.anchorOrigin;
        return React.createElement(
            "div",
            { className: cx('tooltip-container', {
                    visible: open,
                    'anchor-top': anchorOrigin.vertical === 'top',
                    'anchor-bottom': anchorOrigin.vertical === 'bottom',
                    'anchor-left': anchorOrigin.horizontal === 'left',
                    'anchor-right': anchorOrigin.horizontal === 'right',
                    'anchor-center': anchorOrigin.horizontal === 'center'
                }), "data-jsx": 3207991532
            },
            React.createElement(_style2.default, {
                styleId: 3207991532,
                css: ".tooltip-container[data-jsx=\"3207991532\"] {-webkit-transform: translateX(-50%);transform: translateX(-50%);z-index: 9999;-webkit-transition: opacity ease-out 0.2s;transition: opacity ease-out 0.2s;visibility: hidden;opacity: 0;}.tooltip-container.anchor-top[data-jsx=\"3207991532\"] {margin-bottom: 16px}.tooltip-container.anchor-top[data-jsx=\"3207991532\"][data-jsx=\"3207991532\"] .big-triangle[data-jsx=\"3207991532\"] {bottom: -10px;}.tooltip-container.anchor-bottom[data-jsx=\"3207991532\"] {margin-top: 16px}.tooltip-container.anchor-bottom[data-jsx=\"3207991532\"][data-jsx=\"3207991532\"] .big-triangle[data-jsx=\"3207991532\"] {top: -10px;border-width: 0 10px 10px 10px;border-color: #f3f4f4 transparent #f3f4f4 transparent;}.tooltip-container.anchor-left[data-jsx=\"3207991532\"] {left: 0;-webkit-transform: none;transform: none}.tooltip-container.anchor-left[data-jsx=\"3207991532\"][data-jsx=\"3207991532\"] .big-triangle[data-jsx=\"3207991532\"] {left: 25px;}.tooltip-container.anchor-right[data-jsx=\"3207991532\"] {right: 0;-webkit-transform: none;transform: none}.tooltip-container.anchor-right[data-jsx=\"3207991532\"][data-jsx=\"3207991532\"] .big-triangle[data-jsx=\"3207991532\"] {right: 25px;}.tooltip-container.anchor-center[data-jsx=\"3207991532\"][data-jsx=\"3207991532\"] .big-triangle[data-jsx=\"3207991532\"] {left: calc(50% - 10px);}.tooltip-container.visible[data-jsx=\"3207991532\"] {visibility: visible;opacity: 1;}.tooltip-container[data-jsx=\"3207991532\"] .tooltip-content[data-jsx=\"3207991532\"] {background-color: #f3f4f4;box-shadow: 0 1px 6px 0 rgba(0, 0, 0, .15);}.big-triangle[data-jsx=\"3207991532\"] {width: 0;height: 0;border-style: solid;border-width: 10px 10px 0 10px;border-color: #f3f4f4 transparent transparent transparent;}.absolute,\n.tooltip-container[data-jsx=\"3207991532\"],\n.big-triangle[data-jsx=\"3207991532\"] {position: absolute;}.tl,\n.tooltip-container[data-jsx=\"3207991532\"] {text-align: left;}.bottom100,\n.tooltip-container.anchor-top[data-jsx=\"3207991532\"] {bottom: 100%;}.top100,\n.tooltip-container.anchor-bottom[data-jsx=\"3207991532\"] {top: 100%;}.left50,\n.tooltip-container.anchor-left[data-jsx=\"3207991532\"],\n.tooltip-container.anchor-center[data-jsx=\"3207991532\"] {left: 50%;}.right50,\n.tooltip-container.anchor-right[data-jsx=\"3207991532\"] {right: 50%;}.left50,\n.tooltip-container.anchor-left[data-jsx=\"3207991532\"],\n.tooltip-container.anchor-center[data-jsx=\"3207991532\"] {left: 50%;}.nowrap,\n.tooltip-container[data-jsx=\"3207991532\"] .tooltip-content[data-jsx=\"3207991532\"] {white-space: nowrap;}.br2,\n.tooltip-container[data-jsx=\"3207991532\"] .tooltip-content[data-jsx=\"3207991532\"] {border-radius: 2px;}.black50,\n.tooltip-container[data-jsx=\"3207991532\"] .tooltip-content[data-jsx=\"3207991532\"] {color: rgba(0,0,0,.5);}.ph16,\n.tooltip-container[data-jsx=\"3207991532\"] .tooltip-content[data-jsx=\"3207991532\"] {padding-left: 16px;padding-right: 16px;}.pv12,\n.tooltip-container[data-jsx=\"3207991532\"] .tooltip-content[data-jsx=\"3207991532\"] {padding-top: 12px;padding-bottom: 12px;}.flex,\n.tooltip-container[data-jsx=\"3207991532\"] .tooltip-content[data-jsx=\"3207991532\"] {display: -ms-flexbox;display: flex;}.itemsCenter,\n.tooltip-container[data-jsx=\"3207991532\"] .tooltip-content[data-jsx=\"3207991532\"] {-webkit-box-align: center;-ms-flex-align: center;-ms-grid-row-align: center;align-items: center;}.absolute,\n.tooltip-container[data-jsx=\"3207991532\"],\n.big-triangle[data-jsx=\"3207991532\"] {position: absolute;}"
            }),
            React.createElement(
                "div",
                { className: "tooltip-content", onClick: onClick, "data-jsx": 3207991532
                },
                React.createElement("div", { className: "big-triangle", "data-jsx": 3207991532
                }),
                children
            )
        );
    };
    Tooltip.defaultProps = {
        anchorOrigin: {
            vertical: 'top',
            horizontal: 'center'
        }
    };
    return Tooltip;
}(React.PureComponent);
exports.default = Tooltip;
//# sourceMappingURL=Tooltip.jsx.map