"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var ReactDOM = require("react-dom");
var cx = require("classnames");
var Tooltip = /** @class */ (function (_super) {
    __extends(Tooltip, _super);
    function Tooltip() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.handleClickOutside = function (event) {
            if (!_this.props.open) {
                return;
            }
            var domNode = ReactDOM.findDOMNode(_this);
            if ((!domNode || !domNode.contains(event.target)) &&
                typeof _this.props.onClose !== 'undefined') {
                event.stopPropagation();
                _this.props.onClose(event);
            }
        };
        return _this;
    }
    Tooltip.prototype.componentDidMount = function () {
        document.addEventListener('click', this.handleClickOutside.bind(this), true);
    };
    Tooltip.prototype.componentWillUnmount = function () {
        document.removeEventListener('click', this.handleClickOutside.bind(this), true);
    };
    Tooltip.prototype.render = function () {
        var _a = this.props, open = _a.open, children = _a.children, onClick = _a.onClick;
        var anchorOrigin = this.props.anchorOrigin;
        return (<div className={cx('tooltip-container', {
            visible: open,
            'anchor-top': anchorOrigin.vertical === 'top',
            'anchor-bottom': anchorOrigin.vertical === 'bottom',
            'anchor-left': anchorOrigin.horizontal === 'left',
            'anchor-right': anchorOrigin.horizontal === 'right',
            'anchor-center': anchorOrigin.horizontal === 'center',
        })}>
        <style jsx={true}>{"\n          .tooltip-container {\n            @p: .absolute, .tl;\n            transform: translateX(-50%);\n            z-index: 9999;\n            transition: opacity ease-out 0.2s;\n            visibility: hidden;\n            opacity: 0;\n          }\n          .tooltip-container.anchor-top {\n            @p: .bottom100;\n            margin-bottom: 16px;\n            & .big-triangle {\n              bottom: -10px;\n            }\n          }\n          .tooltip-container.anchor-bottom {\n            @p: .top100;\n            margin-top: 16px;\n            & .big-triangle {\n              top: -10px;\n              border-width: 0 10px 10px 10px;\n              border-color: #f3f4f4 transparent #f3f4f4 transparent;\n            }\n          }\n          .tooltip-container.anchor-left {\n            @p: .left50;\n            left: 0;\n            transform: none;\n            & .big-triangle {\n              left: 25px;\n            }\n          }\n          .tooltip-container.anchor-right {\n            @p: .right50;\n            right: 0;\n            transform: none;\n            & .big-triangle {\n              right: 25px;\n            }\n          }\n          .tooltip-container.anchor-center {\n            @p: .left50;\n\n            & .big-triangle {\n              left: calc(50% - 10px);\n            }\n          }\n          .tooltip-container.visible {\n            visibility: visible;\n            opacity: 1;\n          }\n          .tooltip-container .tooltip-content {\n            @p: .nowrap, .br2, .black50, .ph16, .pv12, .flex, .itemsCenter;\n            background-color: #f3f4f4;\n            box-shadow: 0 1px 6px 0 rgba(0, 0, 0, 0.15);\n          }\n          .big-triangle {\n            @p: .absolute;\n            width: 0;\n            height: 0;\n            border-style: solid;\n            border-width: 10px 10px 0 10px;\n            border-color: #f3f4f4 transparent transparent transparent;\n          }\n        "}</style>
        <div className="tooltip-content" onClick={onClick}>
          <div className="big-triangle"/>
          {children}
        </div>
      </div>);
    };
    Tooltip.defaultProps = {
        anchorOrigin: {
            vertical: 'top',
            horizontal: 'center',
        },
    };
    return Tooltip;
}(React.PureComponent));
exports.default = Tooltip;
//# sourceMappingURL=Tooltip.jsx.map